/*						*\
    PetriX - Tetris For Linux. 18 Luty 1999
    Piotrek Skowronek.
    piotr@skowro.net
    pskowronek@adfinem.net
    skylark@wizard.ae.krakow.pl

    Licencja: Lesser GPL
    
    2006.11.25 - code altered to achieve easy
                 building on currently used
                 Linuxes.
    2008.02.18 - added greater delay loop, to
                 make game work on Macs/macosx.
\*						*/


#include "newtypes.h"
#include "hiscore.h"

#include <iostream>
#include <stdio.h>
#include <string.h>

#include <time.h>       

#include <curses.h>
#include <signal.h>   

using namespace std;

static void finish(int sig);



#define MAX_LENGTH 04                           // Length of square-side
int     MAX_COLORS;
int     TETRIS_CHAR='X';
int     TETRIS_BLANK=' ';
BOOL    SOUND = TRUE;



    /* Coordinates */

#define TETRIS_WND_X 3
#define TETRIS_WND_Y 2
#define TETRIS_WND_WIDTH  23
#define TETRIS_WND_HEIGHT 19

#define STATUS_X 30
#define STATUS_Y 1
#define STATUS_WIDTH  46
#define STATUS_HEIGHT 6
#define FILLED_X STATUS_X+2
#define FILLED_Y STATUS_Y+2
#define LEVEL_X  STATUS_X+2
#define LEVEL_Y  STATUS_Y+3
#define SCORE_X  STATUS_X+2
#define SCORE_Y	 STATUS_Y+4

#define HISCORES_X 30
#define HISCORES_Y 8
#define HISCORES_WIDTH 46
#define HISCORES_HEIGHT 13

int     CurrentLevel=1;
long    CurrentScore=0;


typedef BYTE T_Shape[MAX_LENGTH][MAX_LENGTH];

T_Shape Shapes[]  =  {{0,0,0,0,                 // Map of tetris shapes
		       0,1,1,1,
		       0,0,1,0,
		       0,0,0,0},
		      {0,0,1,0,
		       0,0,1,0,
		       0,0,1,0,
		       0,0,1,0},
		      {0,0,0,0,
		       0,0,1,1,
		       0,1,1,0,
		       0,0,0,0},
		      {0,0,0,0,
		       0,1,1,0,
		       0,0,1,1,
		       0,0,0,0},
		      {0,0,0,0,
		       0,1,1,1,
		       0,1,0,0,
		       0,0,0,0},
		      {0,0,0,0,
		       0,1,0,0,
		       0,1,1,1,
		       0,0,0,0},
		      {0,0,0,0,
		       0,1,1,0,
		       0,1,1,0,
		       0,0,0,0}
		       };

class T_Tetris   {
			public:
			T_Tetris(int At_x_pos_,int At_y_pos_,int x_end, int y_end, T_Shape *TetrisTable, int HowMany_)
			{
				width=(x_end-At_x_pos_)/2;   // Dims of tetris-game array
				height=y_end-At_y_pos_;
				At_x_pos=At_x_pos_;          // Paint at positions...
				At_y_pos=At_y_pos_;
				HowMany=HowMany_;            // How many tetrises are ?
				FilledLines=0;               // Filled & killed lines
				LastKilledLines=0;           // How many last killed lines	
				IsNewTetrisFlying=FALSE;
				Point2Tetris=TetrisTable;    // Save da pointer to tetris-map
				/* Memory allocation */
				table=(BYTE *) malloc(width*height);
				buffer=(BYTE *) malloc(width*height);
				tetris=(T_Shape *) malloc(MAX_LENGTH*MAX_LENGTH);
				if (!table)  ExitMsg("Out of memory.\n");
				if (!buffer) ExitMsg("Out of memory.\n");
				if (!tetris) ExitMsg("Out of memory.\n");
				memset(table,0,width*height);    // Clean-up
				memset(buffer,0,width*height);   // Clean-up, too.
				NewTetris();
				GameOver=FALSE;
			}
			~T_Tetris(void)
			{
                                /* Dispose allocated memory */
                                free(table);
                                free(buffer);
                                free(tetris);
                        }
                        int  FilledLines;        // How many f(/k)illed lines
			int  LastKilledLines;	 // How many last killed lines 			
			BOOL IsNewTetrisFlying;  // TRUE if engine has put new
                        int  X_Pos, Y_Pos;       // Current tetris at pos.
                        int  At_x_pos, At_y_pos; // Paint at positions
                        int  WhichTetris;        // Which tetris (from map) is moved
                        int  TetrisColor;        // Color of current tetris
                        int  HowMany;            // Map of tetrises in array
			int  Part;               // To show part of tetris in the top
                        int  width, height;      // Dims of tetris-game array
                        BOOL GameOver;           // Is Game Over ?
                        BYTE *table;             // Point to tetris-game array
                        BYTE *buffer;            // Buffer to show tetris
                        T_Shape *Point2Tetris;   // Saved point to tetris-map
                        T_Shape *tetris;         // Current moved tetris

                        void Play(void)          // Playing......
                        {
                                int x,y;
                                if (!Check(0,1))      // Is collision course ?
                                {
                                        if (Part!=0)  // There is no room for tetris
                                        {             //        * GAME OVER *
                                                memmove(buffer,table, width*height);
                                                TetrisColor=MAX_COLORS;
 
                                                Part=0;
                                                PutTetris(buffer);
						GameOver=TRUE;
                                                return;
                                        };
                                        PutTetris(table); // put da tetris in table
                                        NewTetris();
                                        RemoveLines();
                                } else
                                {
                                if (Part!=0) Part--;
                                        else Y_Pos++;
                                };
                                memmove(buffer,table, width*height);
                                PutTetris(buffer);
                                return;
                        };
                        BOOL Move(int x_move, int y_move) // Move by vector
                        {
                                if (Y_Pos==0)     // Show next part of tetris
                                {
				 if (x_move!=0) return FALSE; // fuck !
                                 Part-=y_move;
                                 if (Part<0)      // Ups, show entire tetris
                                 {
                                        y_move=-Part;
                                        Part=0;
                                 } else y_move=0; // If not Ups then stay where you are
                                 };
                                if (!Check(x_move,y_move)) return FALSE;  // Ups, Not enough room...
                                X_Pos+=x_move;
                                Y_Pos+=y_move;
                                memmove(buffer, table, width*height);
                                PutTetris(buffer);  // Repaint tetris
                                return TRUE;
                        };
                        BOOL Rotate()       // Anti-Clock-wise(? 8) rotation
                        {                   // of saved tetris.
                                int  x,y;
                                T_Shape temp;

                                memmove(temp,tetris,MAX_LENGTH*MAX_LENGTH);
                                for (y=0; y<MAX_LENGTH; y++)
                                for (x=0; x<MAX_LENGTH; x++)
                                  (* tetris)[MAX_LENGTH-1-x][y]=temp[y][x];

                                if (Check(0,0)) // is enough room to rotate ?
                                {
                                        memmove(buffer,table, width*height);
                                        PutTetris(buffer);
                                        return TRUE;
                                };
                                memmove(tetris,temp,MAX_LENGTH*MAX_LENGTH);
                                return FALSE;
                        };


                        void Paint()       // Paint entire array
                        {
			   int x,y, temp;

                           for (y=0; y<height; y++)
                           {
                           move(At_y_pos+y,At_x_pos);
                           temp=y*width;
                           for (x=0; x<width << 1; x++)
                           {
                                if (!buffer[temp+(x >> 1)])
                                {
					addch(TETRIS_BLANK);
                                }
                                        else
                                {
					addch(TETRIS_CHAR | COLOR_PAIR(buffer[temp+(x >> 1)] ));					
                                };
                           };
			   };
                        };

                        private:
                        BOOL Check(int x_add, int y_add) // Check for collision
                        {
                           int x,y;

                           for (y=Part; y<MAX_LENGTH; y++)
                           for (x=0; x<MAX_LENGTH; x++)
                           if ((* tetris)[y][x]!=0)
                           {
                               if (table[(Y_Pos+y+y_add-Part)*width+X_Pos+x+x_add]!=0) return FALSE;
                               if (((X_Pos+x+x_add)<0) || ((X_Pos+x+x_add)>=width)) return FALSE;
                               if (((Y_Pos+y+y_add-Part)<0) || ((Y_Pos+y+y_add-Part)>=height)) return FALSE;
                           };
                           return TRUE;
                        };
                        void PutTetris(BYTE *buffer) // Put tetris in array
			{
                           int x,y;
			   
                           for (y=Part; y<MAX_LENGTH; y++)
                           for (x=0; x<MAX_LENGTH; x++)
			       if ((* tetris)[y][x]!=0)
                                buffer[(Y_Pos+y-Part)*width+X_Pos+x]=TetrisColor;
                        };
                        void RemoveLines()           // Removes filled lines
                        {
                           int x,y;

                           for (y=0; y<height; y++)
                           for (x=0; x<width; x++)
                                if (table[y*width+x]==0) break;
                                else
                                if (x==width-1)
                                {
                                    FilledLines++;
				    LastKilledLines++;
                                    memset(table,0,width);
				    
				    memmove(table+width,table,y*width);
				    if (SOUND) beep();
                                };
                        };
                        void NewTetris()
			{
				Y_Pos=0;
				X_Pos=width/2-MAX_LENGTH/2;  // Center da tetris
				Part=MAX_LENGTH;             // Show part of tetris at begin
				WhichTetris=rand()%HowMany; // Find 1st tetris to show
				TetrisColor=rand()%MAX_COLORS+1;    // Find da color of that tetris
				/* Copy actual used tetris to table */
				memmove(tetris,Point2Tetris[WhichTetris],MAX_LENGTH*MAX_LENGTH);
				
  			        IsNewTetrisFlying=TRUE;				
			};
			void ExitMsg(char *msg)      // Print msg and Exit
			{
				printf("%s",msg);
				exit(0);
			};
		 };

		
void PaintBorder(int xbeg, int ybeg, int xend, int yend, int color, char *title)
{
	int i;
	for (i=xbeg; i<xend; i++) 
	{ mvaddch(ybeg,i,'-' | COLOR_PAIR(color));	
	  refresh(); 
	};
	mvaddch(ybeg,xend,'+' | COLOR_PAIR(color));	
	for (i=ybeg+1; i<yend; i++) 
	{ mvaddch(i,xend,'|' | COLOR_PAIR(color));		
	  refresh(); 
	};
	mvaddch(yend,xend,'+' | COLOR_PAIR(color));	
	for (i=xend-1; i>xbeg; i--) 
	{ mvaddch(yend,i,'-' | COLOR_PAIR(color));		
	  refresh(); 
	};
	mvaddch(yend,xbeg,'+' | COLOR_PAIR(color));		
	for (i=yend-1; i>ybeg; i--) 
	{ mvaddch(i,xbeg,'|' | COLOR_PAIR(color));			
	  refresh(); 
	};
	mvaddch(ybeg,xbeg,'+' | COLOR_PAIR(color));		
	
	mvaddstr(ybeg,xbeg+(xend-xbeg)/2-strlen(title)/2,title);
};

int main(void)
{
	char text[80];
	int  ch;

	cout << "PetriX! - Tetris dla Linucha, 18 Luty 1999, FreeWare" << endl
	     << "Autor: Piotr Skowronek, piotr@skowro.net" << endl
	     << endl
	     << "Kierowanie: strzalki lub J,I,L;  Zrzucanie: K,spacja" << endl
	     << "W(y)laczanie dzwieku:  S;  Pauza: P;  Koniec: ESC, Q" << endl
	     << endl
	     << "Nacisnij ENTER....";
	getchar();
	cout << "Let's rock !" << endl;
	     
	signal(SIGINT, finish);         /* arrange interrupts to terminate */

	WINDOW *window;
	window=initscr();     
                 /* initialize the curses library */
	keypad(stdscr, TRUE);  		/* enable keyboard mapping */
	nonl();         		/* tell curses not to do NL->CR/NL on output */
	cbreak();       		/* take input chars one at a time, no wait for \n */
	noecho();       		/* don't echo input */
	nodelay(window,TRUE);		/* Don't wait for a key when kbbuffer is empty */
	intrflush(window,TRUE);		/* ups, i've forgot */

	if (has_colors())
	{
    	    start_color();

    	    init_pair(0, COLOR_BLACK, COLOR_BLACK);
    	    init_pair(1, COLOR_GREEN, COLOR_BLACK);
    	    init_pair(2, COLOR_RED, COLOR_BLACK);
    	    init_pair(3, COLOR_CYAN, COLOR_BLACK);
    	    init_pair(4, COLOR_MAGENTA, COLOR_BLACK);
    	    init_pair(5, COLOR_BLUE, COLOR_BLACK);
    	    init_pair(6, COLOR_YELLOW, COLOR_BLACK);
    	    init_pair(7, COLOR_WHITE, COLOR_BLACK);	
	
	    MAX_COLORS=7;
	} else
    	    MAX_COLORS=1;

	    	
		/* Init random generator */
        time_t t;	
        srand((unsigned) time(&t));	
	
	
	PaintBorder(TETRIS_WND_X-1,
		    TETRIS_WND_Y-1,
		    TETRIS_WND_X+(TETRIS_WND_WIDTH)/2*2,
		    TETRIS_WND_Y+TETRIS_WND_HEIGHT, COLOR_YELLOW, "< PetriX! >");
	
	PaintBorder(STATUS_X,
		    STATUS_Y,
		    STATUS_X+STATUS_WIDTH,
		    STATUS_Y+STATUS_HEIGHT, COLOR_YELLOW, "< Status >");

	PaintBorder(HISCORES_X,
		    HISCORES_Y,
		    HISCORES_X+HISCORES_WIDTH,
		    HISCORES_Y+HISCORES_HEIGHT, COLOR_YELLOW, "< Scorki >");
	
        T_HiScores HiScores;
        char Name[20] = "";
        long Score = 0;
        int  FilledLines = 0, FirstLevel, LastLevel = 0;


	if (strlen(getenv("HOME"))<60) strcpy(text,getenv("HOME"));
	strcat(text,"/.petrix.scorki");	
        HiScores.Init(text);
	for (int i=0; i<10; i++)
	{
    	    HiScores.Get(i,Name,&Score,&FilledLines,&FirstLevel,&LastLevel);
	    if (!strlen(Name)) sprintf(text,"      --"); else
			       sprintf(text,"%s",Name);
	    mvaddstr(HISCORES_Y+2+i,HISCORES_X+2, text);	
            sprintf(text,"Wyn: %06li Lin: %04i Poz: %02i", Score, FilledLines, LastLevel);
	    mvaddstr(HISCORES_Y+2+i,HISCORES_X+16, text);	
	};
	
	
	
		/* Ignition of Tetris engine */
	T_Tetris Tetris(TETRIS_WND_X,
		        TETRIS_WND_Y,
			TETRIS_WND_X+TETRIS_WND_WIDTH,
			TETRIS_WND_Y+TETRIS_WND_HEIGHT,
			Shapes, 
			sizeof(Shapes)/(MAX_LENGTH*MAX_LENGTH));


	nodelay(window,TRUE);		/* Don't wait for a key when kbbuffer is empty */				
	
	while (!Tetris.GameOver)
        {
	for (int i=0; i<10; i++)
	{
	ch=getch();    		
	flushinp();
	if (ch!=ERR)
	{
	    switch (ch)
    	    {
		case ERR: break;
		case 'q':
		case 'Q':
                case 27:  	finish(0);
		case 'i':
		case 'I':
                case KEY_UP:    if (Tetris.Rotate()) Tetris.Paint();
				break;
		case 'j':
		case 'J':
                case KEY_LEFT:  if (Tetris.Move(-1,0)) Tetris.Paint();
                                break;
		case 'l':
		case 'L':
                case KEY_RIGHT: if (Tetris.Move(+1,0)) Tetris.Paint();;
                                break;
		case 'k':
		case 'K':
		case 32:
		case 13:
                case KEY_DOWN:  while (Tetris.Move(0,+1));
                                Tetris.Paint();
                                break;
		case 's':
		case 'S':	SOUND=!SOUND;
				break;
		case 'p':
		case 'P':       while (getch()==ERR)
		                {
		                    usleep(20000);
		                }
				break;
		default:	break;
    	    };
//	refresh();
	};
	usleep(20000/CurrentLevel);
	};
        Tetris.Play();
        Tetris.Paint();
	
	if (Tetris.IsNewTetrisFlying) 
	{
	    CurrentScore+=CurrentLevel*50;
	    Tetris.IsNewTetrisFlying=FALSE;
	};

	if (Tetris.LastKilledLines) 
	{
	    CurrentScore+=Tetris.LastKilledLines*100*CurrentLevel;
	    Tetris.LastKilledLines=0;
	};
	
	CurrentLevel=Tetris.FilledLines/10+1;
		
	sprintf(text,"Linie                :              %06d",Tetris.FilledLines);
	mvaddstr(FILLED_Y,FILLED_X,text);
	sprintf(text,"Poziom               :              %06d",CurrentLevel);
	
	mvaddstr(LEVEL_Y,LEVEL_X,text);
	sprintf(text,"Punkty               :              %06d",CurrentScore);
	mvaddstr(SCORE_Y,SCORE_X,text);	
	refresh();
	};
	
	
	mvaddstr(TETRIS_WND_Y+TETRIS_WND_HEIGHT+1,TETRIS_WND_X,"   ++ GAME OVER ++   ");	
	refresh();
	
	
	long score=0;
	HiScores.Get(10,NULL,&score,NULL,NULL,NULL);
	if (CurrentScore>score)
	{
	echo();
	nodelay(window,FALSE);
	mvaddstr(TETRIS_WND_Y+TETRIS_WND_HEIGHT+1,HISCORES_X, "Wpisz swoje imie: ");
	mvgetnstr(TETRIS_WND_Y+TETRIS_WND_HEIGHT+1,HISCORES_X+20, text, 12);
        HiScores.Add(text,CurrentScore,Tetris.FilledLines,1,CurrentLevel);
	
	HiScores.Update();
	};	
	endwin();	
	finish(0);
	
	return 0;
};


static void finish(int sig)
{
    endwin();
    if (sig) cout << "Goddam ! Whatcha' doin' ?" << endl;
    cout << "Program napisany przez: Piotr Skowronek, E-mail: piotr@skowro.net." << endl
	 << "Zajrzyj: http://skowro.net. Bledy mozna zglaszac na e-mail." << endl;
    exit(0);
}
